
_I2C_Initialize:

;defs.c,6 :: 		void I2C_Initialize(unsigned long freq) {//Begin IIC as master
;defs.c,8 :: 		TRISC |= 0x18; // Set SDA and SCL pins as input pins
	MOVLW      24
	IORWF      TRISC+0, 1
;defs.c,9 :: 		TRISA.F0 = 0;
	BCF        TRISA+0, 0
;defs.c,11 :: 		SSPCON  = 0b00101000;    //pg84/234
	MOVLW      40
	MOVWF      SSPCON+0
;defs.c,12 :: 		SSPCON2 = 0b00000000;    //pg85/234
	CLRF       SSPCON2+0
;defs.c,14 :: 		SSPADD = _XTAL_FREQ/(4*freq) - 1; // Setting Clock Speed pg99/234
	MOVF       FARG_I2C_Initialize_freq+0, 0
	MOVWF      R4+0
	MOVF       FARG_I2C_Initialize_freq+1, 0
	MOVWF      R4+1
	MOVF       FARG_I2C_Initialize_freq+2, 0
	MOVWF      R4+2
	MOVF       FARG_I2C_Initialize_freq+3, 0
	MOVWF      R4+3
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVLW      36
	MOVWF      R0+1
	MOVLW      244
	MOVWF      R0+2
	MOVLW      0
	MOVWF      R0+3
	CALL       _Div_32x32_U+0
	DECF       R0+0, 0
	MOVWF      SSPADD+0
;defs.c,15 :: 		SSPSTAT = 0b00000000;    //pg83/234
	CLRF       SSPSTAT+0
;defs.c,17 :: 		return;
;defs.c,18 :: 		}//I2C_Initialize
L_end_I2C_Initialize:
	RETURN
; end of _I2C_Initialize

_I2C_Hold:

;defs.c,20 :: 		void I2C_Hold() {
;defs.c,24 :: 		delay_us(100);
	MOVLW      133
	MOVWF      R13+0
L_I2C_Hold0:
	DECFSZ     R13+0, 1
	GOTO       L_I2C_Hold0
;defs.c,29 :: 		return;
;defs.c,30 :: 		}//I2C_Hold
L_end_I2C_Hold:
	RETURN
; end of _I2C_Hold

_I2C_Start:

;defs.c,32 :: 		void I2C_Start() {
;defs.c,34 :: 		I2C_Hold();  //Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;defs.c,35 :: 		SSPCON2.SEN = 1;     //Begin IIC pg85/234
	BSF        SSPCON2+0, 0
;defs.c,36 :: 		while(SSPCON2.SEN);
L_I2C_Start1:
	BTFSS      SSPCON2+0, 0
	GOTO       L_I2C_Start2
	GOTO       L_I2C_Start1
L_I2C_Start2:
;defs.c,38 :: 		return;
;defs.c,39 :: 		}//I2C_Start
L_end_I2C_Start:
	RETURN
; end of _I2C_Start

_I2C_Restart:

;defs.c,41 :: 		void I2C_Restart() {
;defs.c,43 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;defs.c,44 :: 		SSPCON2.RSEN = 1;
	BSF        SSPCON2+0, 1
;defs.c,45 :: 		while(SSPCON2.RSEN);
L_I2C_Restart3:
	BTFSS      SSPCON2+0, 1
	GOTO       L_I2C_Restart4
	GOTO       L_I2C_Restart3
L_I2C_Restart4:
;defs.c,47 :: 		return;
;defs.c,48 :: 		}//I2C_Restart
L_end_I2C_Restart:
	RETURN
; end of _I2C_Restart

_I2C_Stop:

;defs.c,50 :: 		void I2C_Stop() {
;defs.c,52 :: 		I2C_Hold(); //Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;defs.c,53 :: 		SSPCON2.PEN = 1;    //End IIC pg85/234
	BSF        SSPCON2+0, 2
;defs.c,54 :: 		while(SSPCON2.PEN);
L_I2C_Stop5:
	BTFSS      SSPCON2+0, 2
	GOTO       L_I2C_Stop6
	GOTO       L_I2C_Stop5
L_I2C_Stop6:
;defs.c,56 :: 		return;
;defs.c,57 :: 		}//I2C_Stop
L_end_I2C_Stop:
	RETURN
; end of _I2C_Stop

_I2C_Write:

;defs.c,59 :: 		void I2C_Write(unsigned char datum) {
;defs.c,61 :: 		I2C_Hold(); // Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;defs.c,62 :: 		SSPBUF = datum; //pg82/234
	MOVF       FARG_I2C_Write_datum+0, 0
	MOVWF      SSPBUF+0
;defs.c,63 :: 		while(SSPSTAT.BF);
L_I2C_Write7:
	BTFSS      SSPSTAT+0, 0
	GOTO       L_I2C_Write8
	GOTO       L_I2C_Write7
L_I2C_Write8:
;defs.c,65 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;defs.c,67 :: 		if (SSPCON2.ACKSTAT) PORTA.F0 = ~PORTA.F0;
	BTFSS      SSPCON2+0, 6
	GOTO       L_I2C_Write9
	MOVLW      1
	XORWF      PORTA+0, 1
L_I2C_Write9:
;defs.c,69 :: 		return;
;defs.c,70 :: 		}//I2C_Write
L_end_I2C_Write:
	RETURN
; end of _I2C_Write

_I2C_Read:

;defs.c,72 :: 		unsigned char I2C_Read(unsigned char ack) {
;defs.c,76 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;defs.c,77 :: 		SSPCON2.RCEN = 1;
	BSF        SSPCON2+0, 3
;defs.c,78 :: 		while(!SSPSTAT.BF);
L_I2C_Read10:
	BTFSC      SSPSTAT+0, 0
	GOTO       L_I2C_Read11
	GOTO       L_I2C_Read10
L_I2C_Read11:
;defs.c,80 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;defs.c,81 :: 		incoming = SSPBUF;         // get the data saved in SSPBUF
	MOVF       SSPBUF+0, 0
	MOVWF      I2C_Read_incoming_L0+0
;defs.c,83 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;defs.c,84 :: 		SSPCON2.ACKDT = (ack)?0:1; // check if ack bit received
	MOVF       FARG_I2C_Read_ack+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_I2C_Read12
	CLRF       ?FLOC___I2C_ReadT26+0
	GOTO       L_I2C_Read13
L_I2C_Read12:
	MOVLW      1
	MOVWF      ?FLOC___I2C_ReadT26+0
L_I2C_Read13:
	BTFSC      ?FLOC___I2C_ReadT26+0, 0
	GOTO       L__I2C_Read21
	BCF        SSPCON2+0, 5
	GOTO       L__I2C_Read22
L__I2C_Read21:
	BSF        SSPCON2+0, 5
L__I2C_Read22:
;defs.c,85 :: 		SSPCON2.ACKEN = 1;         // pg 85/234
	BSF        SSPCON2+0, 4
;defs.c,87 :: 		return incoming;
	MOVF       I2C_Read_incoming_L0+0, 0
	MOVWF      R0+0
;defs.c,88 :: 		}//I2C_Read
L_end_I2C_Read:
	RETURN
; end of _I2C_Read

defs_Sensor_get:

;defs.c,92 :: 		static unsigned char Sensor_get(Sensor* const me) {
;defs.c,96 :: 		return 0;  // to avoid compiler warnings
	CLRF       R0+0
;defs.c,97 :: 		}//Sensor_get
L_end_Sensor_get:
	RETURN
; end of defs_Sensor_get

defs_Sensor_init:

;defs.c,99 :: 		static void Sensor_init(Sensor* const me) {
;defs.c,103 :: 		return;    // to avoid compiler warnings
;defs.c,104 :: 		}//Sensor_init
L_end_Sensor_init:
	RETURN
; end of defs_Sensor_init

_Sensor_ctor:

;defs.c,106 :: 		void Sensor_ctor(Sensor* const me) {
;defs.c,109 :: 		vtbl.getData = &Sensor_get;
	MOVLW      defs_Sensor_get+0
	MOVWF      Sensor_ctor_vtbl_L0+0
	MOVLW      hi_addr(defs_Sensor_get+0)
	MOVWF      Sensor_ctor_vtbl_L0+1
	MOVLW      FARG_defs_Sensor_get_me+0
	MOVWF      Sensor_ctor_vtbl_L0+2
	MOVLW      hi_addr(FARG_defs_Sensor_get_me+0)
;defs.c,110 :: 		vtbl.init = &Sensor_init;
	MOVLW      defs_Sensor_init+0
	MOVWF      Sensor_ctor_vtbl_L0+3
	MOVLW      hi_addr(defs_Sensor_init+0)
	MOVWF      Sensor_ctor_vtbl_L0+4
	MOVLW      FARG_defs_Sensor_init_me+0
	MOVWF      Sensor_ctor_vtbl_L0+5
	MOVLW      hi_addr(FARG_defs_Sensor_init_me+0)
;defs.c,111 :: 		me->vptr = &vtbl; // "hook" the vptr to the vtbl
	MOVF       FARG_Sensor_ctor_me+0, 0
	MOVWF      FSR
	MOVLW      Sensor_ctor_vtbl_L0+0
	MOVWF      INDF+0
;defs.c,112 :: 		me->I2C_Initialize = &I2C_Initialize;
	INCF       FARG_Sensor_ctor_me+0, 0
	MOVWF      FSR
	MOVLW      _I2C_Initialize+0
	MOVWF      INDF+0
	MOVLW      hi_addr(_I2C_Initialize+0)
	INCF       FSR, 1
	MOVWF      INDF+0
	MOVLW      FARG_I2C_Initialize_freq+0
	INCF       FSR, 1
	MOVWF      INDF+0
	MOVLW      hi_addr(FARG_I2C_Initialize_freq+0)
;defs.c,114 :: 		return;
;defs.c,115 :: 		}//Sensor_ctor
L_end_Sensor_ctor:
	RETURN
; end of _Sensor_ctor

defs_ds1621_getT:

;defs.c,117 :: 		static unsigned char ds1621_getT(Sensor* const me) {
;defs.c,120 :: 		unsigned char address = (*_me).WRITE;
	MOVLW      4
	ADDWF      FARG_defs_ds1621_getT_me+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      defs_ds1621_getT_address_L0+0
;defs.c,123 :: 		I2C_Start();
	CALL       _I2C_Start+0
;defs.c,124 :: 		I2C_Write(address); // Write mode
	MOVF       defs_ds1621_getT_address_L0+0, 0
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,125 :: 		I2C_Write(0xAA); // Access temperature register
	MOVLW      170
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,127 :: 		I2C_Restart();
	CALL       _I2C_Restart+0
;defs.c,128 :: 		I2C_Write(address | 1); // Read mode
	MOVLW      1
	IORWF      defs_ds1621_getT_address_L0+0, 0
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,129 :: 		tH = I2C_Read(1); // Read temperature high, ack
	MOVLW      1
	MOVWF      FARG_I2C_Read_ack+0
	CALL       _I2C_Read+0
;defs.c,130 :: 		tL = I2C_Read(0); // Read temperature high, nack
	CLRF       FARG_I2C_Read_ack+0
	CALL       _I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      defs_ds1621_getT_tL_L0+0
;defs.c,131 :: 		I2C_Stop();
	CALL       _I2C_Stop+0
;defs.c,133 :: 		return (tH<<8) | tL;
	MOVF       defs_ds1621_getT_tL_L0+0, 0
	MOVWF      R0+0
;defs.c,134 :: 		}//ds1621_getT
L_end_ds1621_getT:
	RETURN
; end of defs_ds1621_getT

defs_ds1621_init:

;defs.c,136 :: 		static void ds1621_init(Sensor* const me) {
;defs.c,139 :: 		unsigned char address = (*_me).WRITE;
	MOVLW      4
	ADDWF      FARG_defs_ds1621_init_me+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      defs_ds1621_init_address_L0+0
;defs.c,141 :: 		I2C_Start();
	CALL       _I2C_Start+0
;defs.c,142 :: 		I2C_Write(address); // Write mode
	MOVF       defs_ds1621_init_address_L0+0, 0
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,143 :: 		I2C_Write(0xAC); // Send configuration register address (Access Config)
	MOVLW      172
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,144 :: 		I2C_Write(0x01); // Performs either continuous (0x00) or one-shot (0x01) conversion
	MOVLW      1
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,146 :: 		I2C_Restart();
	CALL       _I2C_Restart+0
;defs.c,147 :: 		I2C_Write(address);
	MOVF       defs_ds1621_init_address_L0+0, 0
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,148 :: 		I2C_Write(0xEE); // Send start temperature conversion command
	MOVLW      238
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;defs.c,149 :: 		I2C_Stop();
	CALL       _I2C_Stop+0
;defs.c,151 :: 		return;
;defs.c,152 :: 		}//ds1621_init
L_end_ds1621_init:
	RETURN
; end of defs_ds1621_init

_ds1621_ctor:

;defs.c,154 :: 		void ds1621_ctor(ds1621* const me, unsigned char WRITE) {
;defs.c,157 :: 		vtbl.getData = &ds1621_getT;
	MOVLW      defs_ds1621_getT+0
	MOVWF      ds1621_ctor_vtbl_L0+0
	MOVLW      hi_addr(defs_ds1621_getT+0)
	MOVWF      ds1621_ctor_vtbl_L0+1
	MOVLW      FARG_defs_ds1621_getT_me+0
	MOVWF      ds1621_ctor_vtbl_L0+2
	MOVLW      hi_addr(FARG_defs_ds1621_getT_me+0)
;defs.c,158 :: 		vtbl.init = &ds1621_init;
	MOVLW      defs_ds1621_init+0
	MOVWF      ds1621_ctor_vtbl_L0+3
	MOVLW      hi_addr(defs_ds1621_init+0)
	MOVWF      ds1621_ctor_vtbl_L0+4
	MOVLW      FARG_defs_ds1621_init_me+0
	MOVWF      ds1621_ctor_vtbl_L0+5
	MOVLW      hi_addr(FARG_defs_ds1621_init_me+0)
;defs.c,160 :: 		Sensor_ctor(&(*me).super);
	MOVF       FARG_ds1621_ctor_me+0, 0
	MOVWF      FARG_Sensor_ctor_me+0
	CALL       _Sensor_ctor+0
;defs.c,161 :: 		me->super.vptr = &vtbl; // override the vptr
	MOVF       FARG_ds1621_ctor_me+0, 0
	MOVWF      FSR
	MOVLW      ds1621_ctor_vtbl_L0+0
	MOVWF      INDF+0
;defs.c,163 :: 		(*me).WRITE = WRITE;
	MOVLW      4
	ADDWF      FARG_ds1621_ctor_me+0, 0
	MOVWF      FSR
	MOVF       FARG_ds1621_ctor_WRITE+0, 0
	MOVWF      INDF+0
;defs.c,165 :: 		return;
;defs.c,166 :: 		}//ds1621_ctor
L_end_ds1621_ctor:
	RETURN
; end of _ds1621_ctor
