#line 1 "C:/Users/Koba/Desktop/libStock/pic16f877_ds1621/object-oriented/defs.c"
#line 1 "c:/users/koba/desktop/libstock/pic16f877_ds1621/object-oriented/defs.h"






typedef struct Superior {
 struct SensorVtbl* vptr;
 void (*I2C_Initialize)(unsigned long freq);
} Sensor;

typedef struct Inferior {
 Sensor super;

 unsigned char WRITE;
} ds1621;

struct SensorVtbl {
 unsigned char (*getData)(Sensor* const me);
 void (*init)(Sensor* const me);
};


void Sensor_ctor(Sensor* const me);
void ds1621_ctor(ds1621* const me, unsigned char WRITE);
#line 1 "c:/program files (x86)/mikroc pro for pic/include/assert.h"
#line 6 "C:/Users/Koba/Desktop/libStock/pic16f877_ds1621/object-oriented/defs.c"
void I2C_Initialize(unsigned long freq) {

 TRISC |= 0x18;
 TRISA.F0 = 0;

 SSPCON = 0b00101000;
 SSPCON2 = 0b00000000;

 SSPADD =  16000000 /(4*freq) - 1;
 SSPSTAT = 0b00000000;

 return;
}

void I2C_Hold() {



 delay_us(100);
#line 29 "C:/Users/Koba/Desktop/libStock/pic16f877_ds1621/object-oriented/defs.c"
 return;
}

void I2C_Start() {

 I2C_Hold();
 SSPCON2.SEN = 1;
 while(SSPCON2.SEN);

 return;
}

void I2C_Restart() {

 I2C_Hold();
 SSPCON2.RSEN = 1;
 while(SSPCON2.RSEN);

 return;
}

void I2C_Stop() {

 I2C_Hold();
 SSPCON2.PEN = 1;
 while(SSPCON2.PEN);

 return;
}

void I2C_Write(unsigned char datum) {

 I2C_Hold();
 SSPBUF = datum;
 while(SSPSTAT.BF);

 I2C_Hold();

 if (SSPCON2.ACKSTAT) PORTA.F0 = ~PORTA.F0;

 return;
}

unsigned char I2C_Read(unsigned char ack) {

 unsigned char incoming;

 I2C_Hold();
 SSPCON2.RCEN = 1;
 while(!SSPSTAT.BF);

 I2C_Hold();
 incoming = SSPBUF;

 I2C_Hold();
 SSPCON2.ACKDT = (ack)?0:1;
 SSPCON2.ACKEN = 1;

 return incoming;
}



static unsigned char Sensor_get(Sensor* const me) {

  ((0) ? (void)0 : ( 1 ) ) ;

 return 0;
}

static void Sensor_init(Sensor* const me) {

  ((0) ? (void)0 : ( 1 ) ) ;

 return;
}

void Sensor_ctor(Sensor* const me) {

 static struct SensorVtbl vtbl;
 vtbl.getData = &Sensor_get;
 vtbl.init = &Sensor_init;
 me->vptr = &vtbl;
 me->I2C_Initialize = &I2C_Initialize;

 return;
}

static unsigned char ds1621_getT(Sensor* const me) {

 ds1621* const _me = (ds1621*)me;
 unsigned char address = (*_me).WRITE;
 unsigned char tH, tL;

 I2C_Start();
 I2C_Write(address);
 I2C_Write(0xAA);

 I2C_Restart();
 I2C_Write(address | 1);
 tH = I2C_Read(1);
 tL = I2C_Read(0);
 I2C_Stop();

 return (tH<<8) | tL;
}

static void ds1621_init(Sensor* const me) {

 ds1621* const _me = (ds1621*)me;
 unsigned char address = (*_me).WRITE;

 I2C_Start();
 I2C_Write(address);
 I2C_Write(0xAC);
 I2C_Write(0x01);

 I2C_Restart();
 I2C_Write(address);
 I2C_Write(0xEE);
 I2C_Stop();

 return;
}

void ds1621_ctor(ds1621* const me, unsigned char WRITE) {

 static struct SensorVtbl vtbl;
 vtbl.getData = &ds1621_getT;
 vtbl.init = &ds1621_init;

 Sensor_ctor(&(*me).super);
 me->super.vptr = &vtbl;

 (*me).WRITE = WRITE;

 return;
}
