#ifndef DEFS_H
#define DEFS_H

// struct SensorVtbl;

// Sensor's attributes ...
typedef struct Superior {
        struct SensorVtbl* vptr;
        void (*I2C_Initialize)(unsigned long freq);
} Sensor;

typedef struct Inferior {
        Sensor super; // <== inherits Sensor, must be first
        // attributes added by this subclass ...
        unsigned char WRITE;
} ds1621;

struct SensorVtbl {
       unsigned char (*getData)(Sensor* const me);
       void (*init)(Sensor* const me);
};

// Sensor's operations (Sensor's interface) ...
void Sensor_ctor(Sensor* const me);
void ds1621_ctor(ds1621* const me, unsigned char WRITE);

#endif