#line 1 "C:/Users/Koba/Desktop/libStock/pic16f877_ds1621/procedural/pic16f877_ds1621.c"






unsigned char I2C_Read(unsigned char ack);
void I2C_Write(unsigned char datum);
void I2C_Stop();
void I2C_Start();
void I2C_Restart();
void I2C_Hold();
void I2C_Initialize(const unsigned long freq);

void ds1621Init();
int readTemp();
unsigned char readCntr();

void main() {

 int T;

 I2C_Initialize(100000);
 ds1621Init();

 while(1) {
 T = readTemp();

 delay_ms(750);
 }

 return;
}

void I2C_Initialize(const unsigned long freq) {


 TRISC |= 0x18;
 TRISA.F0 = 0;

 SSPCON = 0b00101000;
 SSPCON2 = 0b00000000;

 SSPADD =  16000000 /(4*freq) - 1;

 SSPSTAT = 0b00000000;

 return;
}

void I2C_Hold() {



 delay_us(100);
#line 60 "C:/Users/Koba/Desktop/libStock/pic16f877_ds1621/procedural/pic16f877_ds1621.c"
 return;
}

void I2C_Start() {

 I2C_Hold();
 SSPCON2.SEN = 1;
 while(SSPCON2.SEN);

 return;
}

void I2C_Restart() {

 I2C_Hold();
 SSPCON2.RSEN = 1;
 while(SSPCON2.RSEN);

 return;
}

void I2C_Stop() {

 I2C_Hold();
 SSPCON2.PEN = 1;
 while(SSPCON2.PEN);

 return;
}

void I2C_Write(unsigned char datum) {

 I2C_Hold();
 SSPBUF = datum;
 while(SSPSTAT.BF);

 I2C_Hold();

 if (SSPCON2.ACKSTAT) PORTA.F0 = ~PORTA.F0;

 return;
}

unsigned char I2C_Read(unsigned char ack) {

 unsigned char incoming;

 I2C_Hold();
 SSPCON2.RCEN = 1;
 while(!SSPSTAT.BF);

 I2C_Hold();
 incoming = SSPBUF;

 I2C_Hold();
 SSPCON2.ACKDT = (ack)?0:1;
 SSPCON2.ACKEN = 1;

 return incoming;
}

void ds1621Init() {


 I2C_Start();
 I2C_Write( 0x90 );
 I2C_Write(0xAC);
 I2C_Write(0x01);


 I2C_Restart();
 I2C_Write( 0x90 );
 I2C_Write(0xEE);
 I2C_Stop();

 return;
}

int readTemp() {

 unsigned char tH, tL;

 I2C_Start();

 I2C_Write( 0x90 );
 I2C_Write(0xAA);



 I2C_Restart();
 I2C_Write( 0x90  | 0x01);
 tH = I2C_Read(1);
 tL = I2C_Read(0);

 I2C_Stop();

 return (tH<<8) | tL;
}

unsigned char readCntr() {

 unsigned char out;

 I2C_Start();

 I2C_Write( 0x90 );
 I2C_Write(0xA8);



 I2C_Restart();
 I2C_Write( 0x90  | 0x01);
 out = I2C_Read(0);

 I2C_Stop();

 return out;
}
